--- old/usr/src/tools/smatch/src/smatch_assigned_expr.c	Mon Aug  5 08:38:19 2019
+++ new/usr/src/tools/smatch/src/smatch_assigned_expr.c	Mon Aug  5 08:38:19 2019
@@ -28,8 +28,12 @@
 static int my_id;
 static int link_id;
 
+static struct expression *skip_mod;
+
 static void undef(struct sm_state *sm, struct expression *mod_expr)
 {
+	if (mod_expr == skip_mod)
+		return;
 	set_state(my_id, sm->name, sm->sym, &undefined);
 }
 
@@ -55,6 +59,7 @@
 
 static void match_assignment(struct expression *expr)
 {
+	static struct expression *ignored_expr;
 	struct symbol *left_sym, *right_sym;
 	char *left_name = NULL;
 	char *right_name = NULL;
@@ -72,6 +77,12 @@
 			return;
 	}
 
+	if (expr->left == ignored_expr)
+		return;
+	ignored_expr = NULL;
+	if (__in_fake_parameter_assign)
+		ignored_expr = expr->left;
+
 	left_name = expr_to_var_sym(expr->left, &left_sym);
 	if (!left_name || !left_sym)
 		goto free;
@@ -118,6 +129,7 @@
 	if (!name || !sym)
 		goto free;
 
+	skip_mod = expr;
 	set_state(my_id, name, sym, alloc_state_expr(right));
 free:
 	free_string(name);
@@ -126,6 +138,7 @@
 void register_assigned_expr(int id)
 {
 	my_id = check_assigned_expr_id = id;
+	set_dynamic_states(check_assigned_expr_id);
 	add_hook(&match_assignment, ASSIGNMENT_HOOK_AFTER);
 	add_modification_hook(my_id, &undef);
 	select_return_states_hook(PARAM_SET, &record_param_assignment);
@@ -134,6 +147,7 @@
 void register_assigned_expr_links(int id)
 {
 	link_id = id;
+	set_dynamic_states(link_id);
 	db_ignore_states(link_id);
 	set_up_link_functions(my_id, link_id);
 }
